local sendmsg = SendChatMessage

local EnabledMsg = {
	[true] = "Enabled",
	[false] = "Disabled",
}

local function PrintMessage(msg)
	print("Robotspeak: "..msg)
end

local defaults = {
	enabled = false,
	hex = true,
	binary = false,
}

local db

local function OnEvent(self, event, addon)
	if addon == "Robotspeak" then
		RobotspeakDB = RobotspeakDB or CopyTable(defaults)
		db = RobotspeakDB
		for k, v in pairs(defaults) do
			if db[k] == nil then
				db[k] = v
			end
		end
		self:UnregisterEvent("ADDON_LOADED")
		PrintMessage(EnabledMsg[db.enabled])
	end
end

local f = CreateFrame("Frame")
f:RegisterEvent("ADDON_LOADED")
f:SetScript("OnEvent", OnEvent)

local ascii = {
	"!",
	"“",
	"#",
	"$",
	"%",
	"&",
	"‘",
	"(",
	")",
	"*",
	"+",
	",",
	"–",
	"/",
	"0",
	"1",
	"2",
	"3",
	"4",
	"5",
	"6",
	"7",
	"8",
	"9",
	":",
	";",
	"<",
	"=",
	">",
	"?",
	"@",
	"A",
	"B",
	"C",
	"D",
	"E",
	"F",
	"G",
	"H",
	"I",
	"J",
	"K",
	"L",
	"M",
	"N",
	"O",
	"P",
	"Q",
	"R",
	"S",
	"T",
	"U",
	"V",
	"W",
	"X",
	"Y",
	"Z",
	"[",
	"]",
	"^",
	"_",
	"`",
	"a",
	"b",
	"c",
	"d",
	"e",
	"f",
	"g",
	"h",
	"i",
	"j",
	"k",
	"l",
	"m",
	"n",
	"o",
	"p",
	"q",
	"r",
	"s",
	"t",
	"u",
	"v",
	"w",
	"x",
	"y",
	"z",
	"{",
	"|",
	"}",
	"~",
}

local hex = {
	"21",
	"22",
	"23",
	"24",
	"25",
	"26",
	"27",
	"28",
	"29",
	"2A",
	"2B",
	"2C",
	"2D",
	"2F",
	"30",
	"31",
	"32",
	"33",
	"34",
	"35",
	"36",
	"37",
	"38",
	"39",
	"3A",
	"3B",
	"3C",
	"3D",
	"3E",
	"3F",
	"40",
	"41",
	"42",
	"43",
	"44",
	"45",
	"46",
	"47",
	"48",
	"49",
	"4A",
	"4B",
	"4C",
	"4D",
	"4E",
	"4F",
	"50",
	"51",
	"52",
	"53",
	"54",
	"55",
	"56",
	"57",
	"58",
	"59",
	"5A",
	"5B",
	"5D",
	"5E",
	"5F",
	"60",
	"61",
	"62",
	"63",
	"64",
	"65",
	"66",
	"67",
	"68",
	"69",
	"6A",
	"6B",
	"6C",
	"6D",
	"6E",
	"6F",
	"70",
	"71",
	"72",
	"73",
	"74",
	"75",
	"76",
	"77",
	"78",
	"79",
	"7A",
	"7B",
	"7C",
	"7D",
	"7E",
}

local binary = {
	"00100001",
	"00100010",
	"00100011",
	"00100100",
	"00100101",
	"00100110",
	"00100111",
	"00101000",
	"00101001",
	"00101010",
	"00101011",
	"00101100",
	"00101101",
	"00101111",
	"00110000",
	"00110001",
	"00110010",
	"00110011",
	"00110100",
	"00110101",
	"00110110",
	"00110111",
	"00111000",
	"00111001",
	"00111010",
	"00111011",
	"00111100",
	"00111101",
	"00111110",
	"00111111",
	"01000000",
	"01000001",
	"01000010",
	"01000011",
	"01000100",
	"01000101",
	"01000110",
	"01000111",
	"01001000",
	"01001001",
	"01001010",
	"01001011",
	"01001100",
	"01001101",
	"01001110",
	"01001111",
	"01010000",
	"01010001",
	"01010010",
	"01010011",
	"01010100",
	"01010101",
	"01010110",
	"01010111",
	"01011000",
	"01011001",
	"01011010",
	"01011011",
	"01011101",
	"01011110",
	"01011111",
	"01100000",
	"01100001",
	"01100010",
	"01100011",
	"01100100",
	"01100101",
	"01100110",
	"01100111",
	"01101000",
	"01101001",
	"01101010",
	"01101011",
	"01101100",
	"01101101",
	"01101110",
	"01101111",
	"01110000",
	"01110001",
	"01110010",
	"01110011",
	"01110100",
	"01110101",
	"01110110",
	"01110111",
	"01111000",
	"01111001",
	"01111010",
	"01111011",
	"01111100",
	"01111101",
	"01111110",
}

function SendChatMessage(msg, chatType, language, channel)
	if db.enabled == true then
		if db.hex == true then
			s = msg:gsub("()"," "):sub(2,-2)
			for i, v in pairs(ascii) do
				local word = "[^%s]+"
				sub = {}
				sub[v] = hex[i]
				s = s:gsub(word, sub)
			end
			s = s:gsub("   "," 20 ")
			sendmsg(s, chatType, language, channel)
		elseif db.binary == true then
			s = msg:gsub("()"," "):sub(2,-2)
			for i, v in pairs(ascii) do
				local word = "[^%s]+"
				sub = {}
				sub[v] = binary[i]
				s = s:gsub(word, sub)
			end
			s = s:gsub("   "," 00100000 ")
			sendmsg(s, chatType, language, channel)
		else
			sendmsg(msg, chatType, language, channel)
		end
	else
		sendmsg(msg, chatType, language, channel)
	end
end

SLASH_ROBOTSPEAK1 = "/robot"
SLASH_ROBOTSPEAK2 = "/robotspeak"

SlashCmdList.ROBOTSPEAK = function(msg)
	if msg == "" then
		db.enabled = not db.enabled
		PrintMessage(EnabledMsg[db.enabled])
	elseif msg:lower() == "binary" then
		if db.enabled == false then
			db.enabled = not db.enabled
		end
		db.binary = true
		db.hex = false
		PrintMessage("01000101 01101110 01100001 01100010 01101100 01100101 01100100".." Binary Mode")
	elseif msg:lower() == "hex" then
		if db.enabled == false then
			db.enabled = not db.enabled
		end
		db.binary = false
		db.hex = true
		PrintMessage("456E61626C6564".." Hex Mode")
	end
end

SLASH_TRANSLATEHEX1 = "/translatehex"
SLASH_TRANSLATEHEX2 = "/thex"

SlashCmdList.TRANSLATEHEX = function(msg)
	s = msg
	for i, v in pairs(hex) do
		local word = "[^%s]+"
		sub = {}
		sub[v] = ascii[i]
		s = s:gsub(word, sub)
	end
	s = s:gsub(" 20 ","Ç")
	s = s:gsub(" ","")
	s = s:gsub("Ç"," ")
	print("Translation: "..s)
end      

SLASH_TRANSLATEBINARY1 = "/translatebinary"
SLASH_TRANSLATEBINARY2 = "/tbinary"

SlashCmdList.TRANSLATEBINARY = function(msg)

	s = msg
	for i, v in pairs(binary) do
		local word = "[^%s]+"
		sub = {}
		sub[v] = ascii[i]
		s = s:gsub(word, sub)
	end
	s = s:gsub(" 00100000 ","Ç")
	s = s:gsub(" ","")
	s = s:gsub("Ç"," ")
	print("Translation: "..s)
end      